import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.Predicate;

import javax.swing.JButton;
import javax.swing.JFrame;

import entities.Developer;

public class MiscTest {

	public static void main(String[] args) {
		// Implement Runnable with lambda
		new Thread(() -> System.out.println("In Java8, Lambda expression rocks !!")).start();

		JFrame dialog = new JFrame("Lambda action handler");
		JButton show = new JButton("Show");
		dialog.getContentPane().add(show);
		dialog.pack();
		dialog.setVisible(true);
		// Action handler with lambda
		show.addActionListener((e) -> {
			System.out.println("Light, Camera, Action !! Lambda expressions Rocks");
		});

		List<String> languages = Arrays.asList("Java", "Scala", "C++", "Haskell", "Lisp");

		System.out.println("Languages which starts with J :");
		filter(languages, (str) -> str.startsWith("J"));

		System.out.println("Languages which ends with a ");
		filter(languages, (str) -> str.endsWith("a"));

		System.out.println("Print all languages :");
		filter(languages, (str) -> true);

		System.out.println("Print no language : ");
		filter(languages, (str) -> false);

		System.out.println("Print language whose length greater than 4:");
		filter(languages, (str) -> str.length() > 4);

		Predicate<String> startsWithJ = (n) -> n.startsWith("J");
		Predicate<String> fourLetterLong = (n) -> n.length() == 4;

		languages.stream().filter(startsWithJ.and(fourLetterLong))
				.forEach((n) -> System.out.println("\nLanguage, which starts with 'J' and four letter long is : " + n));

		// Map reduce
		List<Developer> devs = new ArrayList<Developer>();

		devs.add(new Developer("jason", new BigDecimal("100000"), 10));
		devs.add(new Developer("alvin", new BigDecimal("80000"), 20));
		devs.add(new Developer("iris", new BigDecimal("170000"), 55));
		devs.add(new Developer("mike", new BigDecimal("70000"), 33));
		devs.stream().map((dev) -> dev.getSalary().multiply(new BigDecimal(1.12)).intValue()).sorted()
				.forEach(System.out::println);

		double total = devs.stream().map((dev) -> dev.getSalary().multiply(new BigDecimal(1.12)).intValue())
				.reduce((sum, salary) -> sum + salary).get();
		System.out.println("Total : " + total);

	}

	public static void filter(List<String> names, Predicate<String> condition) {
		for (String name : names) {
			if (condition.test(name)) {
				System.out.println(name + " ");
			}
		}
	}
}
